// gridsvw.h : interface of the CGridSample6View class
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//


#ifndef _MYGRIDVW_H_
#include "mygridvw.h"
#endif

#ifndef _GXWND_H_
#include "gxwnd.h"
#endif

class CGridSample6View : public CMyGridView
{
protected: // create from serialization only
	CGridSample6View();
	DECLARE_DYNCREATE(CGridSample6View)

// Attributes
public:
	CGridSampleDoc* GetDocument();

	CGXGridWnd m_gridWnd;

// Operations
	BOOL ConnectParam();
	void SetupControls();

// Implementation
public:
	virtual ~CGridSample6View();
	virtual void OnInitialUpdate();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CGridSample6View)
	afx_msg void OnViewUseractions();
	afx_msg void OnViewSplitterview();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class CDropDownGridWnd : public CGXGridWnd
{
	DECLARE_DYNAMIC(CDropDownGridWnd)

public:
// Construction
	CDropDownGridWnd();
	BOOL Create(CRect rect, CWnd* pParent = NULL);

// Attributes
public:
	CWnd* m_pMsgWnd;

// Operations
public:

// Implementation
public:
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	// CGXGridWnd overridden methods
	virtual void OnInitialUpdate();
	virtual BOOL ProcessKeys(CWnd* pSender, UINT nMessage, UINT nChar, UINT nRepCnt = 1, UINT flags = 0);
	virtual BOOL OnLButtonHitRowCol(ROWCOL nHitRow, ROWCOL nHitCol, ROWCOL nDragRow, ROWCOL nDragCol, CPoint point, UINT flags, WORD nHitState);
	virtual BOOL OnActivateGrid( BOOL bActivate );

	// Generated message map functions
	//{{AFX_MSG(CDropDownGridWnd)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

class CDropGridControl: public CGXEditControl
{
	DECLARE_CONTROL(CDropGridControl)

public:
	// Constructor & Destructor
	CDropGridControl(CGXGridCore* pGrid, UINT nEditID, UINT nDropGridID);
	virtual ~CDropGridControl();

	virtual CRect GetCellRect(ROWCOL nRow, ROWCOL nCol, LPRECT rectItem = NULL, const CGXStyle* pStyle = NULL);

protected:
	virtual void Init(ROWCOL nRow, ROWCOL nCol);
	virtual void OnInitChilds(ROWCOL nRow, ROWCOL nCol, const CRect& rect);
	virtual void OnClickedButton(CGXChild* pChild);
	virtual BOOL MouseActivate(CWnd* pDesktopWnd, UINT nHitTest, UINT message, int& retval);

	// Attributes:
	CGXChild*       m_pButton;
	UINT            m_nDropGridID;
	CDropDownGridWnd*   m_pDropDownWnd;
	CDropDownGridWnd m_GridWnd;

	// Generated message map functions
protected:
	//{{AFX_MSG(CDropGridControl)
	afx_msg LRESULT OnListBoxEnd(WPARAM, LPARAM);
	afx_msg LRESULT OnListBoxCancel(WPARAM, LPARAM);
	afx_msg LRESULT OnListBoxChanged(WPARAM, LPARAM);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in gridsvw.cpp
inline CGridSampleDoc* CGridSample6View::GetDocument()
   { return (CGridSampleDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
