// gridsvw7.h : interface of the CGridSample7View class
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//

#ifndef _MYGRIDVW_H_
#include "mygridvw.h"
#endif

#ifndef _GXCTRL_H_
#include "gxctrl.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CHeaderButton control

class CHeaderButton: public CGXStatic
{
	DECLARE_CONTROL(CHeaderButton)

public:
	// Member functions

	CHeaderButton(CGXGridCore* pGrid);
	virtual ~CHeaderButton();

	virtual void Draw(CDC* pDC, CRect rect, ROWCOL nRow, ROWCOL nCol, const CGXStyle& style, const CGXStyle* pStandardStyle);
	virtual BOOL MouseMove(UINT nFlags, CPoint pt, UINT nHitState);
	virtual BOOL LButtonDown(UINT nFlags, CPoint pt, UINT nHitState);
	virtual BOOL LButtonUp(UINT nFlags, CPoint pt, UINT nHitState);
	virtual BOOL RButtonDown(UINT nFlags, CPoint pt, UINT nHitState);
	virtual BOOL RButtonUp(UINT nFlags, CPoint pt, UINT nHitState);
	virtual BOOL LButtonDblClk(UINT nFlags, CPoint point);
	virtual void OnClickedButton(CGXChild* pChild);
	virtual void InvertBorders(CDC* pDC, const CRect& r);
	virtual BOOL KeyPressed(UINT nMessage, UINT nChar, UINT nRepCnt, UINT flags);

	// Attributes:
protected:
	BOOL m_bPressed;
	BOOL m_bMouseDown;
};


/////////////////////////////////////////////////////////////////////////////
// CGridSample7View view

class CGridSample7View : public CMyGridView
{
protected: // create from serialization only
	CGridSample7View();
	DECLARE_DYNCREATE(CGridSample7View)

// Attributes
public:
	CGridSampleDoc* GetDocument();

	ROWCOL m_nLastDragCol;

// Operations
	BOOL ConnectParam();
	void SetupControls();
	void DrawDragLine(ROWCOL nCol, BOOL bCurrent);

// Implementation
public:
	virtual ~CGridSample7View();
	virtual void OnInitialUpdate();
	virtual BOOL OnLButtonHitRowCol(ROWCOL nHitRow, ROWCOL nHitCol, ROWCOL nDragRow, ROWCOL nDragCol, CPoint point, UINT flags, WORD nHitState);
	virtual BOOL OnLButtonDblClkRowCol(ROWCOL nRow, ROWCOL nCol, UINT nFlags, CPoint pt);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CGridSample7View)
	afx_msg void OnViewUseractions();
	afx_msg void OnViewSplitterview();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in gridsvw.cpp
inline CGridSampleDoc* CGridSample7View::GetDocument()
   { return (CGridSampleDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
