// gridsvw8.h : interface of the CGridSample8View class
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//

#ifndef _MYGRIDVW_H_
#include "mygridvw.h"
#endif

#ifndef _GXCTRL_H_
#include "gxctrl.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CGridSample8CheckBox

class CGXScrollTip;

// owner drawn checkbox

class CGridSample8CheckBox: public CGXCheckBox
{
public:
	CGridSample8CheckBox(CGXGridCore* pGrid);
	virtual COLORREF GetColorValue(COLORREF rgb, BOOL bPrint);
};

/////////////////////////////////////////////////////////////////////////////
// CGridSample8View view

class CGridSample8View : public CMyGridView
{
protected: // create from serialization only
	CGridSample8View();
	DECLARE_DYNCREATE(CGridSample8View)

// Attributes
public:
	CGridSampleDoc* GetDocument();

	LONG nValue1, nValue2, nValue3;
	ROWCOL m_nProgBarRow, m_nProgBarCol;
	BOOL m_bTimerRunning;

// Scrolltips
#if _MFC_VER >= 0x0400
	CGXScrollTip*	m_pScrollTip;
#endif

// Operations
	BOOL ConnectParam();
	void SetupControls();
	void UpdateProgressDisplay();

// Implementation
public:
	virtual ~CGridSample8View();
	virtual void OnInitialUpdate();
	virtual void OnActivateView(BOOL, CView*, CView*);
	virtual void OnClickedButtonRowCol(ROWCOL nRow, ROWCOL nCol);
	virtual BOOL CanActivateGrid(BOOL bActivate);
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CGridSample8View)
	afx_msg void OnViewUseractions();
	afx_msg void OnViewSplitterview();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in gridsvw.cpp
inline CGridSampleDoc* CGridSample8View::GetDocument()
   { return (CGridSampleDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
