// mygridvw.h : interface of the CMyGridView class
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//


#ifndef _MYGRIDVW_H_
#define _MYGRIDVW_H_

#ifndef _GXRESRC_H_
#include "gxresrc.h"
#endif

#ifndef _GXVW_H_
#include "gxvw.h"
#endif

#ifndef _GXCTRL_H_
#include "gxctrl.h"
#endif

#ifndef _GXEXT_H_
#include "gxext.h"
#endif

#ifndef _GXRTF_H_
#include "gxrtf.h"
#endif

#ifndef _GXOLE_H_
#include "gxole.h"
#endif

class CMyGridView : public CGXGridView
{
protected: // create from serialization only
	CMyGridView();
	DECLARE_DYNCREATE(CMyGridView)

// Attributes
public:
#if _MFC_VER >= 0x0400
	CGXGridDropTarget m_objDndDropTarget;
#endif

// Operations
public:
	BOOL NeedStyle(const CGXStyle& styleNeeded, BOOL& bRet);
	void SetStyle(const CGXStyle& style, GXModifyType mt = gxOverride);
	void SetStyle(const CGXStyle* pStyle, GXModifyType mt, BOOL bExpandRange = FALSE);

// Overrides
	// virtual CGXStyle* CreateStyle();
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMyGridView)
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMyGridView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMyGridView)
	afx_msg void OnFileHeaderfooter();
	afx_msg void OnFilePageSetup();
	afx_msg void OnEditInsertcol();
	afx_msg void OnEditInsertrow();
	afx_msg void OnEditRemovecols();
	afx_msg void OnEditRemoverows();
	afx_msg void OnView100();
	afx_msg void OnViewProperties();
	afx_msg void OnViewReadonly();
	afx_msg void OnViewZoomin();
	afx_msg void OnViewZoomout();
	afx_msg void OnFormatAlignCenter();
	afx_msg void OnFormatAlignLeft();
	afx_msg void OnFormatAlignRight();
	afx_msg void OnFormatCells();
	afx_msg void OnFormatCovercells();
	afx_msg void OnFormatFreezecols();
	afx_msg void OnFormatFreezerows();
	afx_msg void OnFormatLookup();
	afx_msg void OnFormatRemovecover();
	afx_msg void OnFormatStyleBold();
	afx_msg void OnFormatStyleItalic();
	afx_msg void OnFormatStyleUnderline();
	afx_msg void OnFormatStyles();
	afx_msg void OnFormatUnfreezecols();
	afx_msg void OnFormatUnfreezerows();
	afx_msg void OnUpdateEditRemovecols(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditRemoverows(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatAlignCenter(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatAlignLeft(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatAlignRight(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatCells(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatCovercells(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatFreezecols(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatFreezerows(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatLookup(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatRemovecover(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatStyleBold(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatStyleItalic(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatStyleUnderline(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatUnfreezecols(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFormatUnfreezerows(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewReadonly(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoomin(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewZoomout(CCmdUI* pCmdUI);
	afx_msg void OnEditClear();
	afx_msg void OnUpdateEditClear(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnFormatResizecols();
	afx_msg void OnUpdateFormatResizecols(CCmdUI* pCmdUI);
	afx_msg void OnFormatResizerows();
	afx_msg void OnUpdateFormatResizerows(CCmdUI* pCmdUI);
	afx_msg void OnViewWysiwig();
	afx_msg void OnUpdateViewWysiwig(CCmdUI* pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////


#endif // _MYGRIDVW_H_
