// browsdoc.h : header file
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//

#ifndef _BROWSEDOC_H_
#define _BROWSEDOC_H_

#ifndef _DBFILE_H_
#include "dbfile.h"
#endif
#ifndef _GXPARAM_H_
#include "gxcore.h"
#endif
#ifndef _GXSTYLES_H_
#include "gxstyles.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CDBaseBrowserDoc document

class CDBaseBrowserDoc : public CDocument
{
protected:
	CDBaseBrowserDoc();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDBaseBrowserDoc)

// Attributes
public:
	CDBaseFile m_dbfile;
	CGXGridParam m_param;
	CGXStylesMap m_stylesMap;
	CGXProperties m_properties;
	CGXMapDWordToLong m_columnIdMap;

	WORD m_wStyleNumeric,
		 m_wStyleText,
		 m_wStyleDate,
		 m_wStyleLogical;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDBaseBrowserDoc)
	public:
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);
	protected:
	virtual BOOL OnNewDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CDBaseBrowserDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CDBaseBrowserDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#endif // _BROWSEDOC_H_
