// browsevw.h : header file
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//

#ifndef _BROWSEVW_H_
#define _BROWSEVW_H_

#ifndef _MYGRIDVW_H_
#include "mygridvw.h"
#endif
#ifndef _BROWSDOC_H_
#include "browsdoc.h"
#endif

/////////////////////////////////////////////////////////////////////////////
// CDBaseBrowserView view

class CDBaseBrowserView : public CMyGridView
{
protected:
	CDBaseBrowserView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CDBaseBrowserView)

// Attributes
public:
	CDBaseBrowserDoc* GetDocument()
		{ ASSERT_VALID(m_pDocument); return (CDBaseBrowserDoc*) m_pDocument; }

	CField* GetField(ROWCOL nCol);
	int GetFieldId(ROWCOL nCol);

// Operations
public:
	virtual ROWCOL GetRowCount();
	virtual ROWCOL GetColCount();

	virtual BOOL   GetStyleRowCol(ROWCOL nRow, ROWCOL nCol, CGXStyle& style, GXModifyType mt, int nType = 0);
	virtual BOOL   StoreStyleRowCol(ROWCOL nRow, ROWCOL nCol, const CGXStyle* pStyle, GXModifyType mt, int nType);

	virtual int   GetColWidth(ROWCOL nCol);
	virtual BOOL   StoreColWidth(ROWCOL nCol, int nWidth = 0);

	virtual BOOL   StoreMoveCols(ROWCOL nFromCol, ROWCOL nToCol, ROWCOL nDestCol, BOOL bProcessed = FALSE);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDBaseBrowserView)
	public:
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CDBaseBrowserView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CDBaseBrowserView)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
#endif // _BROWSEVW_H_
