// gridsdoc.h : interface of the CGridSampleDoc class
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//

class CGridSampleDoc : public CDocument
{
protected: // create from serialization only
	CGridSampleDoc();
	DECLARE_DYNCREATE(CGridSampleDoc)

// Attributes
public:
	CObArray    m_ParamArray;
	CByteArray  m_bOwnParamArray;

// Operations
public:
	CObject* GetParam(int nViewID);
	void SetParam(int nViewID, CObject* pParam, BOOL bMustDelete = TRUE);

// Implementation
public:
	virtual ~CGridSampleDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
	virtual BOOL OnNewDocument();
	virtual BOOL OnOpenDocument(LPCTSTR pszPathName);
	virtual BOOL OnSaveDocument(LPCTSTR pszPathName);
	virtual void DeleteContents();
	virtual BOOL CanCloseFrame(CFrameWnd* pFrame);

// Generated message map functions
protected:
	//{{AFX_MSG(CGridSampleDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
