// gridsvw3.h : interface of the CGridSample3View class
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//


#ifndef _MYGRIDVW_H_
#include "mygridvw.h"
#endif

class CGridSample3View : public CMyGridView
{
protected: // create from serialization only
	CGridSample3View();
	DECLARE_DYNCREATE(CGridSample3View)

// Attributes
public:
	CGridSampleDoc* GetDocument();

	WORD m_wStyleCombo,
		 m_wStyleError;

// Operations
	BOOL ConnectParam();
	void SetupBaseStyles();
	void Instructions(LPCTSTR szInstruct);

	virtual BOOL OnSelDragColsStart(ROWCOL nFirstCol, ROWCOL nLastCol);
	virtual BOOL OnSelDragColsMove(ROWCOL, ROWCOL, ROWCOL nDestCol);

// Implementation
public:
	virtual ~CGridSample3View();
	virtual void OnInitialUpdate();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CGridSample3View)
	afx_msg void OnViewUseractions();
	afx_msg void OnViewSplitterview();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in gridsvw.cpp
inline CGridSampleDoc* CGridSample3View::GetDocument()
   { return (CGridSampleDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
