// gridsvw4.h : interface of the CGridSample4View class
//

// This is a part of the Objective Grid C++ Library.
// Copyright (C) 1995,1996 ClassWorks, Stefan Hoenig.
// All rights reserved.
//
// This source code is only intended as a supplement to
// the Objective Grid Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding
// the Objective Grid product.
//


#ifndef _MYGRIDVW_H_
#include "mygridvw.h"
#endif

class CMyProperties : public CGXProperties
{
	DECLARE_SERIAL(CMyProperties)
public:
	CMyProperties();

	// substitute tokens
	virtual CString SubstTokenText(int nToken, CString& sRest);

protected:
	int m_nTokDate;
	int m_nTokText;
};

class CGridSample4View : public CMyGridView
{
protected: // create from serialization only
	CGridSample4View();
	DECLARE_DYNCREATE(CGridSample4View)

// Attributes
public:
	CGridSampleDoc* GetDocument();

// Operations
	BOOL ConnectParam();
	void SetupProperties();

// Implementation
public:
	virtual ~CGridSample4View();
	virtual void OnInitialUpdate();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CGridSample4View)
	afx_msg void OnViewUseractions();
	afx_msg void OnViewSplitterview();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in gridsvw.cpp
inline CGridSampleDoc* CGridSample4View::GetDocument()
   { return (CGridSampleDoc*) m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
